<html>

	<head>
		<script src="https://alqemia.com/public/utilsaotracode.build.js"></script>
	</head>
	
	<body>

			<div id="display">
			</div>
			<input type="text" id="keyboard">
			</input>

			<!--
			OLD :
			
			<div id="bootProgram" style="display:none;">
				BTOM|HARD|11|0;
				BTOM|HARD|12|1;
				BTOM|HARD|13|2;
				BTOM|HARD|14|3;
				BTOM|HARD|15|4;
				BTOM|HARD|16|5;
				BTOM|HARD|17|6;
				BTOM|HARD|18|7;
				BTOM|HARD|19|8;
				GOTO|0;
				# START OF NON-BOOT PROGRAMS;
				DATA|Hello world|STR;
				MTOB|0|DISP|0;
				DATA|void|STR;
				DATA|void|STR;
				DATA|void|STR;
				DATA|void|STR;
				DATA|void|STR;
				DATA|void|STR;
				END;
			</div>
			-->
			<!-- In hard drive : -->
			<div id="bootProgram" style="display:none;">
				BTOM|HARD|17|0;
				BTOM|HARD|18|1;
				BTOM|HARD|19|2;
				BTOM|HARD|20|3;
				BTOM|HARD|21|4;
				BTOM|HARD|22|5;
				BTOM|HARD|23|6;
				BTOM|HARD|24|7;
				BTOM|HARD|25|8;
				BTOM|HARD|26|9;
				BTOM|HARD|27|10;
				BTOM|HARD|28|11;
				BTOM|HARD|29|12;
				BTOM|HARD|30|13;
				BTOM|HARD|31|14;
				GOTO|0;
				# START OF NON-BOOT PROGRAMS;
				DATA|0|INT;
				DATA|10|INT;
				DATA|1|INT;
				ADDI|0|2|0;
				MTOB|0|DISP|0;
				COMP|0|1;
				GOTO|9;
				GOTO|3;
				GOTO|3;
				MTOB|0|DISP|0;
				END;
			</div>
			
			<script>


				// BASE FUNCTIONS INTERFACE:
				/*
					-PHYSICAL INSTRUCTIONS for memory operations : (minimal set = 8 instructions !)
					
					COMP|memAddress1|memAddress2;
					ADDI|memAddress1|memAddress2|memAddress3;		(other mathematical functions will be in global software methods...)
					NAND|memAddress1|memAddress2|memAddress3;		(other logical functions will be in global software methods...)
					
					GOTO|memAddressInstrLine;
					
					MTOB|memAddress|busName|busAddr;
					BTOM|busName|busAddr|memAddress;
					
					DATA|value|type|parent;
					END;
					
					DATA TYPES :
					BOO, INT, FLT, STR, OBJ (arrays are objects with attributes....attributes order always matters.)
					
					-COMPILATION CLUES : (null is emptyness !)
					int variable;
					: 
			241	DATA|0|INT|;

					float variable=0;
					: 
			335	DATA|0.0|FLT|;

					string variable="";
					: 
			345	DATA|''|STR|;
					
					obj object;
					:
			355	DATA||OBJ|;
					
					
					obj object=new Car();
					:
			458	DATA|Car|OBJ|; (<-line number)
			459	DATA|ArrayList|OBJ|458;
			460	DATA|Wheel|OBJ|459;
			461	DATA|10|INT|460;
			462	DATA|14.5|INT|460;
			463	DATA|Wheel|OBJ|459;
			464	DATA|10|INT|463;
			465	DATA|14.5|INT|463;
			466	DATA|Wheel|OBJ|459;
			467	DATA|10|INT|466;
			468	DATA|14.5|INT|466;
			469	DATA|Wheel|OBJ|459;
			470	DATA|22|INT|469;
			471	DATA|14.5|INT|469;
			472	DATA|Driver|OBJ|458;
			473	DATA|Jean Dupont|STR|472;
			474	DATA|42|INT|472;


			
					int a=12;
					a+=2;
					:
			100	DATA|12|INT|;
			101	DATA|2|INT|;
			102	ADDI|100|101|100;

			
					int a=3;
					int b=5;
					int c=10;
					if(a<=b || b<=c){...}
					:
			100	DATA|3|INT|;
			101	DATA|5|INT|;
			102	DATA|10|INT|;
			103	DATA|0|BOO|;
			104	COMP|100|101;
			105	GOTO 108				# @100 equals @101
			106	GOTO 108				# @100 < @101
			107	GOTO 150				# @100 > @101
			108	NAND|103|103|103	#INVERT false = true
			109	DATA|0|BOO|;
			110   COMP|101|102;
			111	GOTO 114				# @101 equals @102
			112	GOTO 114				# @101 < @102
			113	GOTO 150				# @101 > @102			
			114	NAND|109|109|109	#INVERT false = true
			115	DATA|0|BOO|;
			116	NAND|103|109|115;
			115	DATA|0|BOO|
			117	
			118	#//////////////
			120
			121
			122
			...
			150							#end of if block
			
			
	
				*/
					
				// Flow control method :
				// goes to instruction line +1 if equals, line +2 if value at mem address 1 is less, line +3 if reg is more, than value at mem address 2
				function add(memAddress1,memAddress2,memAddress3){}
				function nan(memAddress1,memAddress2,memAddress3){}
				function compareValueMemGoto(memAddress1,memAddress2){}
				function goTo(instrLine){}
				
				// I/O methods :
				function fromMemToBus(memAddress,busName,busAddr){}
				function fromBusToMem(busName,busAddr,memAddress){}
				
				// memory structure :
				// // - program instructions (read-only) ; from beginning
				// // - memory (read-write)				 ; from end
				// peripherics :
				// // - mass (read-write), accessed by bus
				// mass storage structure :
				// // - boot program on first lines
				
				// ------------------------------------------------
				
				// The computer implementation :
				var HARD_DRIVE_BOOT_SECTOR_LINES_NUMBER=16;
				var MEMORY_LINES_MAX_NUMBER=100;
				var memory=new Array(MEMORY_LINES_MAX_NUMBER);
				// (line numbers starts from 0)
				var INSTRUCTIONS_ZONE_START_LINE_NUMBER=0;
				var INSTRUCTIONS_ZONE_END_LINE_NUMBER=Math.floor(MEMORY_LINES_MAX_NUMBER/2)-1;
				var RAM_ZONE_START_LINE_NUMBER=INSTRUCTIONS_ZONE_START_LINE_NUMBER+1;
				var RAM_ZONE_END_LINE_NUMBER=MEMORY_LINES_MAX_NUMBER-1;
				var SEP_INSTR="|";
				var SEP_PROGRAM_INSTRUCTIONS=";";
				var CHAR_COMMENT="#"
				var CLOCK_RATE_MILLIS=100;
				var currentInstructionLine=0;
				
				var BUSES_MAX_ADDRESSES=new Object();

				var HARDDRIVE_BUS="HARD"; // Hard drive
				BUSES_MAX_ADDRESSES[HARDDRIVE_BUS]=100;
				var buses=new Object();
				buses[HARDDRIVE_BUS]=new Array(BUSES_MAX_ADDRESSES[HARDDRIVE_BUS]);

				var DISPLAY_BUS="DISP"; // Screen console
				BUSES_MAX_ADDRESSES[DISPLAY_BUS]=100;
				buses[DISPLAY_BUS]=new Array(BUSES_MAX_ADDRESSES[DISPLAY_BUS]);
				buses[DISPLAY_BUS][0]="";
				
				var KEYBOARD_BUS="KEYB"; // Input console
				BUSES_MAX_ADDRESSES[KEYBOARD_BUS]=10;
				buses[KEYBOARD_BUS]=new Array(BUSES_MAX_ADDRESSES[KEYBOARD_BUS]);
				buses[KEYBOARD_BUS][0]="";
				
				// Methods implementations :
				// (All these methods will have to be physically implemented)
				
				function getValueAndType(instructionStrParam){
					var instructionStr=instructionStrParam;
					if(!instructionStr){
						return null;
					}
					instructionStr=instructionStrParam.trim();
					
					// Ignore comments :
					if(!instructionStr || empty(instructionStr) || instructionStr.charAt(0)===CHAR_COMMENT){
						return null;
					}
					
					var split=instructionStr.split(SEP_INSTR);
					if(empty(split))	return null;
					
					// Stop on end of program :
					if(instructionStr==="END")	return null;
					
					if(split[0]==="DATA"){
						return {value:split[1],type:split[2]};
					}

					return null;
				};
			
		
				
				add=function(memAddress1,memAddress2,memAddress3){
					var vt1=getValueAndType(memory[memAddress1]);
					var vt2=getValueAndType(memory[memAddress2]);
					var vt3=getValueAndType(memory[memAddress3]);
					
					if(!vt1 || !vt2)	return;
					if(vt1.type!==vt2.type)	return;
					if(vt1.type==="INT")
						memory[memAddress3]="DATA"+SEP_INSTR+(parseInt(vt1.value)+parseInt(vt2.value))+SEP_INSTR+"INT";
					else if(vt1.type==="STR")
						memory[memAddress3]="DATA"+SEP_INSTR+(vt1.value+vt2.value)+SEP_INSTR+"STR";
					currentInstructionLine+=1;

				};
			
				
				nand=function(memAddress1,memAddress2,memAddress3){
					var vt1=getValueAndType(memory[memAddress1]);
					var vt2=getValueAndType(memory[memAddress2]);
					var vt3=getValueAndType(memory[memAddress3]);
					
					if(!vt1 || !vt2)	return;
					if(vt1.type!==vt2.type)	return;
					if(vt1.type==="BOO"){
						var b1=vt1.value==="1"?true:false;
						var b2=vt2.value==="1"?true:false;
						memory[memAddress3]="DATA"+SEP_INSTR+( !(b1 && b2 )?"1":"0" )+SEP_INSTR+"BOO";
					}
					currentInstructionLine+=1;

				};
				
				compareValueMemGoto=function(memAddress1,memAddress2){
				
					var vt1=getValueAndType(memory[memAddress1]);
					var vt2=getValueAndType(memory[memAddress2]);

					
					// Equals
					if(!vt1 && !vt2){
						currentInstructionLine+=1;
						return;
					}
					// vt1 < vt2
					if(!vt1 && vt2){
						currentInstructionLine+=2;
						return;
					}
					// vt1 > vt2
					if(vt1 && !vt2){
						currentInstructionLine+=3;
						return;
					}
					
					// Equals
					if(vt1.value===vt2.value && vt1.type===vt2.type){
						currentInstructionLine+=1;
						return;
					}
					// vt1 < vt2
					if(vt1.value < vt2.value && vt1.type===vt2.type){
						currentInstructionLine+=2;
						return;
					}
					// vt1 > vt2
					if(vt1.value > vt2.value && vt1.type===vt2.type){
						currentInstructionLine+=3;
						return;
					}
					
				};
				
				goTo=function(instrLine){
					currentInstructionLine=instrLine;
				};
				fromMemToBus=function(memAddress,busName,busAddr){
					if(memAddress<INSTRUCTIONS_ZONE_START_LINE_NUMBER || RAM_ZONE_END_LINE_NUMBER<memAddress)	return;
					////DD
					//log("memory["+memAddress+"]:"+memory[memAddress]);
					if(!memory[memAddress]){
						buses[busName][busAddr]=null;
						currentInstructionLine+=1;
						return;
					}
					buses[busName][busAddr]=memory[memAddress].trim();
					currentInstructionLine+=1;
				};
				
				fromBusToMem=function(busName,busAddr,memAddress){
					if(memAddress<INSTRUCTIONS_ZONE_START_LINE_NUMBER || RAM_ZONE_END_LINE_NUMBER<memAddress)	return;
					////DD
					//log("buses["+busName+"]["+busAddr+"]:"+buses[busName][busAddr]);
					if(!buses[busName][busAddr]){
						memory[memAddress]=null;
						currentInstructionLine+=1;
						return;
					}
					memory[memAddress]=buses[busName][busAddr].trim();
					currentInstructionLine+=1;
				};
				
				function executeInstruction(instructionStrParam){
					if(currentInstructionLine<INSTRUCTIONS_ZONE_START_LINE_NUMBER || INSTRUCTIONS_ZONE_END_LINE_NUMBER<currentInstructionLine) return false;
					var instructionStr=instructionStrParam;
					if(!instructionStr){
						currentInstructionLine+=1;
						return true;
					}
					instructionStr=instructionStrParam.trim();

					
					// Ignore comments and empty lines :
					if(!instructionStr || empty(instructionStr) || instructionStr.charAt(0)===CHAR_COMMENT){
						currentInstructionLine+=1;
						return true;
					}

					// Stop on end of program :
					if(instructionStr==="END")	return false;

					
					var split=instructionStr.split(SEP_INSTR);
					if(empty(split))	return false;
					
					
					if(split[0]==="COMP"){
						var memAddress1=parseInt(split[1]);
						var memAddress2=parseInt(split[2]);
						compareValueMemGoto(memAddress1,memAddress2);
					}else if(split[0]==="GOTO"){
						var instrLine=parseInt(split[1]);
						goTo(instrLine);
					}else if(split[0]==="MTOB"){
						var memAddress=parseInt(split[1]);
						var busName=split[2];
						var busAddr=parseInt(split[3]);
						fromMemToBus(memAddress,busName,busAddr);
					}else if(split[0]==="BTOM"){
						var busName=split[1];
						var busAddr=parseInt(split[2]);
						var memAddress=parseInt(split[3]);
						fromBusToMem(busName,busAddr,memAddress);
					}else if(split[0]==="ADDI"){
						var memAddress1=parseInt(split[1]);
						var memAddress2=parseInt(split[2]);
						var memAddress3=parseInt(split[3]);
						add(memAddress1,memAddress2,memAddress3);
					}else if(split[0]==="DATA"){
						// Ignore data lines :
						currentInstructionLine+=1;
						return true;
					}
					return true;
				}

				// hard drive :
				buses[HARDDRIVE_BUS]=document.getElementById("bootProgram").innerText.split(SEP_PROGRAM_INSTRUCTIONS);

				// boot :
				// (boot is just putting the 10 first instructions of hard drive in execution memory) :
				for(var i=0;i<HARD_DRIVE_BOOT_SECTOR_LINES_NUMBER;i++)
					memory[i]=buses[HARDDRIVE_BUS][i];
				
				// TRACE
				log("Start of program...");
				
				var pe=setInterval(function () {
				
					buses[KEYBOARD_BUS][0]=document.getElementById("keyboard").value;
					document.getElementById("display").innerHTML=buses[DISPLAY_BUS][0];

					var executionResult=executeInstruction(memory[currentInstructionLine]);
					
					if(!executionResult){
					
						// TRACE
						log("We stop execution");
						
						//TRACE
						log(memory);
				
						clearInterval(pe);;
						return;
					}

					
				}, CLOCK_RATE_MILLIS);
		
			
				
				log("End of program.");	
				
				
				
		</script>
		
	
	</body>

</html>